forked from openssl/openssl
-
Notifications
You must be signed in to change notification settings - Fork 0
Commit
This commit does not belong to any branch on this repository, and may belong to a fork outside of the repository.
Reformat CA.pl.in to follow coding style. Also add "use strict" and "use warnings" Also modify it to exit properly and report only when succeeded. And some perl tweaks via Richard. Reviewed-by: Richard Levitte <[email protected]>
- Loading branch information
Rich Salz
committed
May 1, 2015
1 parent
23a1d5e
commit 5a3aa85
Showing
1 changed file
with
169 additions
and
178 deletions.
There are no files selected for viewing
This file contains bidirectional Unicode text that may be interpreted or compiled differently than what appears below. To review, open the file in an editor that reveals hidden Unicode characters.
Learn more about bidirectional Unicode characters
Original file line number | Diff line number | Diff line change |
---|---|---|
@@ -1,197 +1,188 @@ | ||
#!/usr/local/bin/perl | ||
#!/usr/bin/perl | ||
# | ||
# CA - wrapper around ca to make it easier to use | ||
# | ||
# CA -newca ... will setup the right stuff | ||
# CA -newreq[-nodes] ... will generate a certificate request | ||
# CA -sign ... will sign the generated request and output | ||
# Wrapper around the ca to make it easier to use | ||
# Edit CA.pl.in not CA.pl! | ||
|
||
# default openssl.cnf file has setup as per the following | ||
# demoCA ... where everything is stored | ||
|
||
my $openssl; | ||
if(defined $ENV{OPENSSL}) { | ||
$openssl = $ENV{OPENSSL}; | ||
use strict; | ||
use warnings; | ||
|
||
my $openssl = "openssl"; | ||
if(defined $ENV{'OPENSSL'}) { | ||
$openssl = $ENV{'OPENSSL'}; | ||
} else { | ||
$openssl = "openssl"; | ||
$ENV{OPENSSL} = $openssl; | ||
$ENV{'OPENSSL'} = $openssl; | ||
} | ||
|
||
$SSLEAY_CONFIG=$ENV{"SSLEAY_CONFIG"}; | ||
$DAYS="-days 365"; # 1 year | ||
$CADAYS="-days 1095"; # 3 years | ||
$REQ="$openssl req $SSLEAY_CONFIG"; | ||
$CA="$openssl ca $SSLEAY_CONFIG"; | ||
$VERIFY="$openssl verify"; | ||
$X509="$openssl x509"; | ||
$PKCS12="$openssl pkcs12"; | ||
my $verbose = 1; | ||
|
||
$CATOP="./demoCA"; | ||
$CAKEY="cakey.pem"; | ||
$CAREQ="careq.pem"; | ||
$CACERT="cacert.pem"; | ||
$CACRL="crl.pem"; | ||
my $SSLEAY_CONFIG = $ENV{"SSLEAY_CONFIG"}; | ||
my $DAYS = "-days 365"; | ||
my $CADAYS = "-days 1095"; # 3 years | ||
my $REQ = "$openssl req $SSLEAY_CONFIG"; | ||
my $CA = "$openssl ca $SSLEAY_CONFIG"; | ||
my $VERIFY = "$openssl verify"; | ||
my $X509 = "$openssl x509"; | ||
my $PKCS12 = "$openssl pkcs12"; | ||
|
||
$DIRMODE = 0777; | ||
|
||
$RET = 0; | ||
# default openssl.cnf file has setup as per the following | ||
my $CATOP = "./demoCA"; | ||
my $CAKEY = "cakey.pem"; | ||
my $CAREQ = "careq.pem"; | ||
my $CACERT = "cacert.pem"; | ||
my $CACRL = "crl.pem"; | ||
my $DIRMODE = 0777; | ||
|
||
foreach (@ARGV) { | ||
if ( /^(-\?|-h|-help)$/ ) { | ||
print STDERR "usage: CA -newcert|-newreq|-newreq-nodes|-newca|-sign|-verify\n"; | ||
print STDERR " CA -crl|-revoke cert-filename [reason]\n"; | ||
exit 0; | ||
} elsif (/^-newcert$/) { | ||
# create a certificate | ||
system ("$REQ -new -x509 -keyout newkey.pem -out newcert.pem $DAYS"); | ||
$RET=$?; | ||
print "Certificate is in newcert.pem, private key is in newkey.pem\n" | ||
} elsif (/^-newreq$/) { | ||
# create a certificate request | ||
system ("$REQ -new -keyout newkey.pem -out newreq.pem $DAYS"); | ||
$RET=$?; | ||
print "Request is in newreq.pem, private key is in newkey.pem\n"; | ||
} elsif (/^-newreq-nodes$/) { | ||
# create a certificate request | ||
system ("$REQ -new -nodes -keyout newkey.pem -out newreq.pem $DAYS"); | ||
$RET=$?; | ||
print "Request is in newreq.pem, private key is in newkey.pem\n"; | ||
} elsif (/^-newca$/) { | ||
# if explicitly asked for or it doesn't exist then setup the | ||
# directory structure that Eric likes to manage things | ||
$NEW="1"; | ||
if ( "$NEW" || ! -f "${CATOP}/serial" ) { | ||
# create the directory hierarchy | ||
mkdir $CATOP, $DIRMODE; | ||
mkdir "${CATOP}/certs", $DIRMODE; | ||
mkdir "${CATOP}/crl", $DIRMODE ; | ||
mkdir "${CATOP}/newcerts", $DIRMODE; | ||
mkdir "${CATOP}/private", $DIRMODE; | ||
open OUT, ">${CATOP}/index.txt"; | ||
close OUT; | ||
open OUT, ">${CATOP}/crlnumber"; | ||
print OUT "01\n"; | ||
close OUT; | ||
} | ||
if ( ! -f "${CATOP}/private/$CAKEY" ) { | ||
print "CA certificate filename (or enter to create)\n"; | ||
$FILE = <STDIN>; | ||
my $NEWKEY = "newkey.pem"; | ||
my $NEWREQ = "newreq.pem"; | ||
my $NEWCERT = "newcert.pem"; | ||
my $NEWP12 = "newcert.p12"; | ||
my $RET = 0; | ||
my $WHAT = shift @ARGV; | ||
my $FILE; | ||
|
||
chop $FILE; | ||
# See if reason for a CRL entry is valid; exit if not. | ||
sub crl_reason_ok | ||
{ | ||
my $r = shift; | ||
|
||
# ask user for existing CA certificate | ||
if ($FILE) { | ||
cp_pem($FILE,"${CATOP}/private/$CAKEY", "PRIVATE"); | ||
cp_pem($FILE,"${CATOP}/$CACERT", "CERTIFICATE"); | ||
$RET=$?; | ||
} else { | ||
print "Making CA certificate ...\n"; | ||
system ("$REQ -new -keyout " . | ||
"${CATOP}/private/$CAKEY -out ${CATOP}/$CAREQ"); | ||
system ("$CA -create_serial " . | ||
"-out ${CATOP}/$CACERT $CADAYS -batch " . | ||
"-keyfile ${CATOP}/private/$CAKEY -selfsign " . | ||
"-extensions v3_ca " . | ||
"-infiles ${CATOP}/$CAREQ "); | ||
$RET=$?; | ||
} | ||
} | ||
} elsif (/^-pkcs12$/) { | ||
my $cname = $ARGV[1]; | ||
$cname = "My Certificate" unless defined $cname; | ||
system ("$PKCS12 -in newcert.pem -inkey newkey.pem " . | ||
"-certfile ${CATOP}/$CACERT -out newcert.p12 " . | ||
"-export -name \"$cname\""); | ||
$RET=$?; | ||
print "PKCS #12 file is in newcert.p12\n"; | ||
exit $RET; | ||
} elsif (/^-xsign$/) { | ||
system ("$CA -policy policy_anything -infiles newreq.pem"); | ||
$RET=$?; | ||
} elsif (/^(-sign|-signreq)$/) { | ||
system ("$CA -policy policy_anything -out newcert.pem " . | ||
"-infiles newreq.pem"); | ||
$RET=$?; | ||
print "Signed certificate is in newcert.pem\n"; | ||
} elsif (/^(-signCA)$/) { | ||
system ("$CA -policy policy_anything -out newcert.pem " . | ||
"-extensions v3_ca -infiles newreq.pem"); | ||
$RET=$?; | ||
print "Signed CA certificate is in newcert.pem\n"; | ||
} elsif (/^-signcert$/) { | ||
system ("$X509 -x509toreq -in newreq.pem -signkey newreq.pem " . | ||
"-out tmp.pem"); | ||
system ("$CA -policy policy_anything -out newcert.pem " . | ||
"-infiles tmp.pem"); | ||
$RET = $?; | ||
print "Signed certificate is in newcert.pem\n"; | ||
} elsif (/^-verify$/) { | ||
if (shift) { | ||
foreach $j (@ARGV) { | ||
system ("$VERIFY -CAfile $CATOP/$CACERT $j"); | ||
$RET=$? if ($? != 0); | ||
} | ||
exit $RET; | ||
} else { | ||
system ("$VERIFY -CAfile $CATOP/$CACERT newcert.pem"); | ||
$RET=$?; | ||
exit $RET; | ||
} | ||
} elsif (/^-crl$/) { | ||
system ("$CA -gencrl -out $CATOP/crl/$CACRL"); | ||
$RET=$?; | ||
print "Generated CRL is in $CATOP/crl/$CACRL\n" if (!$RET); | ||
} elsif (/^-revoke$/) { | ||
my $cname = $ARGV[1]; | ||
if (!defined $cname) { | ||
print "Certificate filename is required; reason optional.\n"; | ||
exit 1; | ||
} | ||
my $reason = $ARGV[2]; | ||
$reason = " -crl_reason $reason" | ||
if defined $reason && crl_reason_ok($reason); | ||
my $cmd = "$CA -revoke \"$cname\"".$reason; | ||
system ($cmd); | ||
$RET=$?; | ||
exit $RET; | ||
} else { | ||
print STDERR "Unknown arg $_\n"; | ||
print STDERR "usage: CA -newcert|-newreq|-newreq-nodes|-newca|-sign|-verify\n"; | ||
print STDERR " CA -crl|-revoke cert-filename [reason]\n"; | ||
exit 1; | ||
} | ||
if ($r eq 'unspecified' || $r eq 'keyCompromise' | ||
|| $r eq 'CACompromise' || $r eq 'affiliationChanged' | ||
|| $r eq 'superseded' || $r eq 'cessationOfOperation' | ||
|| $r eq 'certificateHold' || $r eq 'removeFromCRL') { | ||
return 1; | ||
} | ||
print STDERR "Invalid CRL reason; must be one of:\n"; | ||
print STDERR " unspecified, keyCompromise, CACompromise,\n"; | ||
print STDERR " affiliationChanged, superseded, cessationOfOperation\n"; | ||
print STDERR " certificateHold, removeFromCRL"; | ||
exit 1; | ||
} | ||
|
||
exit $RET; | ||
# Copy a PEM-format file; return like exit status (zero means ok) | ||
sub copy_pemfile | ||
{ | ||
my ($infile, $outfile, $bound) = @_; | ||
my $found = 0; | ||
|
||
sub crl_reason_ok { | ||
my ($r) = shift; | ||
if ($r eq 'unspecified' || $r eq 'keyCompromise' || | ||
$r eq 'CACompromise' || $r eq 'affiliationChanged' || | ||
$r eq 'superseded' || $r eq 'cessationOfOperation' || | ||
$r eq 'certificateHold' || $r eq 'removeFromCRL') { | ||
return 1; | ||
} | ||
print STDERR "Invalid CRL reason; must be one of:\n"; | ||
print STDERR " unspecified, keyCompromise, CACompromise,\n"; | ||
print STDERR " affiliationChanged, superseded, cessationOfOperation\n"; | ||
print STDERR " certificateHold, removeFromCRL"; | ||
exit 1; | ||
open IN, $infile || die "Cannot open $infile, $!"; | ||
open OUT, ">$outfile" || die "Cannot write to $outfile, $!"; | ||
while (<IN>) { | ||
$found = 1 if /^-----BEGIN.*$bound/; | ||
print OUT $_ if $found; | ||
$found = 2, last if /^-----END.*$bound/; | ||
} | ||
close IN; | ||
close OUT; | ||
return $found == 2 ? 0 : 1; | ||
} | ||
|
||
sub cp_pem { | ||
my ($infile, $outfile, $bound) = @_; | ||
open IN, $infile; | ||
open OUT, ">$outfile"; | ||
my $flag = 0; | ||
while (<IN>) { | ||
$flag = 1 if (/^-----BEGIN.*$bound/) ; | ||
print OUT $_ if ($flag); | ||
if (/^-----END.*$bound/) { | ||
close IN; | ||
close OUT; | ||
return; | ||
} | ||
# Wrapper around system; useful for debugging. Returns just the exit status | ||
sub run | ||
{ | ||
my $cmd = shift; | ||
print "====\n$cmd\n" if $verbose; | ||
my $status = system($cmd); | ||
print "==> $status\n====\n" if $verbose; | ||
return $status >> 8; | ||
} | ||
|
||
|
||
if ( $WHAT =~ /^(-\?|-h|-help)$/ ) { | ||
print STDERR "usage: CA -newcert|-newreq|-newreq-nodes|-newca|-sign|-verify\n"; | ||
print STDERR " CA -pkcs12 [certname]\n"; | ||
print STDERR " CA -crl|-revoke cert-filename [reason]\n"; | ||
exit 0; | ||
} | ||
if ($WHAT eq '-newcert' ) { | ||
# create a certificate | ||
$RET = run("$REQ -new -x509 -keyout $NEWKEY -out $NEWCERT $DAYS"); | ||
print "Cert is in $NEWCERT, private key is in $NEWKEY\n" if $RET == 0; | ||
} elsif ($WHAT eq '-newreq' ) { | ||
# create a certificate request | ||
$RET = run("$REQ -new -keyout $NEWKEY -out $NEWREQ $DAYS"); | ||
print "Request is in $NEWREQ, private key is in $NEWKEY\n" if $RET == 0; | ||
} elsif ($WHAT eq '-newreq-nodes' ) { | ||
# create a certificate request | ||
$RET = run("$REQ -new -nodes -keyout $NEWKEY -out $NEWREQ $DAYS"); | ||
print "Request is in $NEWREQ, private key is in $NEWKEY\n" if $RET == 0; | ||
} elsif ($WHAT eq '-newca' ) { | ||
# create the directory hierarchy | ||
mkdir ${CATOP}, $DIRMODE; | ||
mkdir "${CATOP}/certs", $DIRMODE; | ||
mkdir "${CATOP}/crl", $DIRMODE ; | ||
mkdir "${CATOP}/newcerts", $DIRMODE; | ||
mkdir "${CATOP}/private", $DIRMODE; | ||
open OUT, ">${CATOP}/index.txt"; | ||
close OUT; | ||
open OUT, ">${CATOP}/crlnumber"; | ||
print OUT "01\n"; | ||
close OUT; | ||
# ask user for existing CA certificate | ||
print "CA certificate filename (or enter to create)\n"; | ||
$FILE = <STDIN>; | ||
chop $FILE; | ||
if ($FILE) { | ||
copy_pemfile($FILE,"${CATOP}/private/$CAKEY", "PRIVATE"); | ||
copy_pemfile($FILE,"${CATOP}/$CACERT", "CERTIFICATE"); | ||
} else { | ||
print "Making CA certificate ...\n"; | ||
$RET = run("$REQ -new -keyout" | ||
. " ${CATOP}/private/$CAKEY" | ||
. " -out ${CATOP}/$CAREQ"); | ||
$RET = run("$CA -create_serial" | ||
. " -out ${CATOP}/$CACERT $CADAYS -batch" | ||
. " -keyfile ${CATOP}/private/$CAKEY -selfsign" | ||
. " -extensions v3_ca" | ||
. " -infiles ${CATOP}/$CAREQ") if $RET == 0; | ||
print "CA certificate is in ${CATOP}/$CACERT\n" if $RET == 0; | ||
} | ||
} elsif ($WHAT eq '-pkcs12' ) { | ||
my $cname = $ARGV[1]; | ||
$cname = "My Certificate" unless defined $cname; | ||
$RET = run("$PKCS12 -in $NEWCERT -inkey $NEWKEY" | ||
. " -certfile ${CATOP}/$CACERT" | ||
. " -out $NEWP12" | ||
. " -export -name \"$cname\""); | ||
print "PKCS #12 file is in $NEWP12\n" if $RET == 0; | ||
} elsif ($WHAT eq '-xsign' ) { | ||
$RET = run("$CA -policy policy_anything -infiles $NEWREQ"); | ||
} elsif ($WHAT eq '-sign' ) { | ||
$RET = run("$CA -policy policy_anything -out $NEWCERT -infiles $NEWREQ"); | ||
print "Signed certificate is in $NEWCERT\n" if $RET == 0; | ||
} elsif ($WHAT eq '-signCA' ) { | ||
$RET = run("$CA -policy policy_anything -out $NEWCERT" | ||
. " -extensions v3_ca -infiles $NEWREQ"); | ||
print "Signed CA certificate is in $NEWCERT\n" if $RET == 0; | ||
} elsif ($WHAT eq '-signcert' ) { | ||
$RET = run("$X509 -x509toreq -in $NEWREQ -signkey $NEWREQ" | ||
. " -out tmp.pem"); | ||
$RET = run("$CA -policy policy_anything -out $NEWCERT" | ||
. " -infiles tmp.pem") if $RET == 0; | ||
print "Signed certificate is in $NEWCERT\n" if $RET == 0; | ||
} elsif ($WHAT eq '-verify' ) { | ||
my @files = @ARGV ? @ARGV : ( $NEWCVERT ); | ||
foreach $file (@files) { | ||
my $status = run("$VERIFY -CAfile ${CATOP}/$CACERT $file"); | ||
$RET = $status if $status != 0; | ||
} | ||
} elsif ($WHAT eq '-crl' ) { | ||
$RET = run("$CA -gencrl -out ${CATOP}/crl/$CACRL"); | ||
print "Generated CRL is in ${CATOP}/crl/$CACRL\n" if $RET == 0; | ||
} elsif ($WHAT eq '-revoke' ) { | ||
my $cname = $ARGV[1]; | ||
if (!defined $cname) { | ||
print "Certificate filename is required; reason optional.\n"; | ||
exit 1; | ||
} | ||
my $reason = $ARGV[2]; | ||
$reason = " -crl_reason $reason" | ||
if defined $reason && crl_reason_ok($reason); | ||
$RET = run("$CA -revoke \"$cname\"" . $reason); | ||
} else { | ||
print STDERR "Unknown arg \"$WHAT\"\n"; | ||
print STDERR "Use -help for help.\n"; | ||
exit 1; | ||
} | ||
|
||
exit $RET; |